// : ex11-1 <board_w> < board_h> <number_of_views> 
// 
// Ͻ/ Ϸ 'p' .  ESC .
// 

#include <cv.h> 
#include <highgui.h> 
#include <stdio.h> 
#include <stdlib.h> 

int n_boards = 0;			//  ڷ  ȴ. 
const int board_dt = 20;	// ü 鸶 20  ٸ Wait 20 frames per chessboard view 
int board_w; 
int board_h; 

int main(int argc, char* argv[]) 
{
	if( argc != 4 )
	{ 
		printf(": Է Ű  ߸Ǿϴ. \n"); 
		return -1;
	}

	board_w  = atoi(argv[1]); 
	board_h  = atoi(argv[2]); 
	n_boards = atoi(argv[3]); 
	int board_n = board_w * board_h; 
	CvSize board_sz = cvSize( board_w, board_h ); 
	CvCapture* capture = cvCreateCameraCapture( 0 ); 
	assert( capture );

	cvNamedWindow( "Calibration" ); 

	//   Ҵ
	CvMat* image_points 		= cvCreateMat(n_boards*board_n, 2, CV_32FC1); 
	CvMat* object_points 		= cvCreateMat(n_boards*board_n, 3, CV_32FC1); 
	CvMat* point_counts 		= cvCreateMat(n_boards, 1, CV_32SC1); 
	CvMat* intrinsic_matrix	 	= cvCreateMat(3, 3, CV_32FC1); 
	CvMat* distortion_coeffs 	= cvCreateMat(4, 1, CV_32FC1);

	CvPoint2D32f* corners = new CvPoint2D32f[board_n]; 
	int corner_count; 
	int successes = 0; 
	int step, frame = 0;
	IplImage *image = cvQueryFrame( capture ); 
	IplImage *gray_image = cvCreateImage(cvGetSize(image), 8, 1); // ȼ

	//  n_boards ڳ  ȹ   . 
	// 
	while( successes < n_boards ) 
	{
		// ڰ ü   ֵ  board_dt Ӹŭ ǳʶڴ.
		if( frame++ % board_dt == 0 )
		{ 
			// ü ڳ ã
			int found = cvFindChessboardCorners(
							image, board_sz, corners, &corner_count, 
							CV_CALIB_CB_ADAPTIVE_THRESH | CV_CALIB_CB_FILTER_QUADS );

			//  ڳʷκ ȼ Ȯ ڳ ǥ Ѵ.
			cvCvtColor(image, gray_image, CV_BGR2GRAY); 
			cvFindCornerSubPix(gray_image, corners, corner_count,
				cvSize(11,11),cvSize(-1,-1), 
				cvTermCriteria( CV_TERMCRIT_EPS+CV_TERMCRIT_ITER, 30, 0.1 ));

			// ڳʸ ׸ ȭ鿡 
			cvDrawChessboardCorners(image, board_sz, corners, corner_count, found); 
			cvShowImage( "Calibration", image );

			//  ڳ ̶ ͸ Ѵ. 
			if( corner_count == board_n ) 
			{ 
				step = successes*board_n; 
				for( int i = step, j = 0 ; j < board_n ; ++i,++j ) 
				{
					CV_MAT_ELEM(*image_points,  float, i, 0) = corners[j].x; 
					CV_MAT_ELEM(*image_points,  float, i, 1) = corners[j].y; 
					CV_MAT_ELEM(*object_points, float, i, 0) = j/board_w; 
					CV_MAT_ELEM(*object_points, float, i, 1) = j%board_w; 
					CV_MAT_ELEM(*object_points, float, i, 2) = 0.0f;
				} 
				CV_MAT_ELEM(*point_counts, int, successes, 0) = board_n; 
				successes++;
			} 
		} // end of if

		// 'p' Ű  Ͻ/ٽ Ǵ ESC Ű    
		int c = cvWaitKey(15); 
		if( c == 'p' )
		{
			c = 0; 
			while( c != 'p' && c != 27 )
				c = cvWaitKey(250);
		} 
		if( c == 27 )
			return 0;
		image = cvQueryFrame( capture ); //   ´.
	} // end of while

	//  ڳ   ˸°  Ҵ
	CvMat* object_points2 = cvCreateMat(successes*board_n, 3, CV_32FC1); 
	CvMat* image_points2  = cvCreateMat(successes*board_n, 2, CV_32FC1); 
	CvMat* point_counts2  = cvCreateMat(successes, 1, CV_32SC1); 

	//  ڳ  Ŀ ű
	//
	// image_points->rows = object_points->rows = successes*board_n; 
	// point_counts->rows = successes; 
	// 
	for( int i = 0 ; i < successes*board_n ; ++i ) 
	{
		CV_MAT_ELEM( *image_points2, float, i, 0) = 
			CV_MAT_ELEM( *image_points, float, i, 0); 
		CV_MAT_ELEM( *image_points2, float, i, 1) = 
			CV_MAT_ELEM( *image_points, float, i, 1); 
		CV_MAT_ELEM(*object_points2, float, i, 0) = 
			CV_MAT_ELEM( *object_points, float, i, 0) ; 
		CV_MAT_ELEM( *object_points2, float, i, 1) = 
			CV_MAT_ELEM( *object_points, float, i, 1) ; 
		CV_MAT_ELEM( *object_points2, float, i, 2) =
			CV_MAT_ELEM( *object_points, float, i, 2) ; 
	} 

	for( int i = 0 ; i < successes ; ++i )
	{ 
		CV_MAT_ELEM( *point_counts2, int, i, 0) =
			CV_MAT_ELEM( *point_counts, int, i, 0); 
	} 

	cvReleaseMat( &object_points ); 
	cvReleaseMat( &image_points ); 
	cvReleaseMat( &point_counts );

	//  Ÿ  1.0 Ͽ   ʱȭ
	// 
	CV_MAT_ELEM( *intrinsic_matrix, float, 0, 0 ) = 1.0f; 
	CV_MAT_ELEM( *intrinsic_matrix, float, 1, 1 ) = 1.0f;

	//  ī޶  Լ!!!
	cvCalibrateCamera2( 
		object_points2, image_points2, 
		point_counts2, cvGetSize( image ), 
		intrinsic_matrix, distortion_coeffs, 
		NULL, NULL, CV_CALIB_FIX_ASPECT_RATIO
		);

	//  İ ְ  Ϸ . (׽Ʈ 뵵)
	cvSave("Intrinsics.xml", intrinsic_matrix); 
	cvSave("Distortion.xml", distortion_coeffs); 

	// Ϸ   İ ְ  ٽ ҷ. (׽Ʈ 뵵)
	CvMat *intrinsic = (CvMat*)cvLoad("Intrinsics.xml"); 
	CvMat *distortion = (CvMat*)cvLoad("Distortion.xml");

	// ְ Ÿ   .
	// 
	IplImage* mapx = cvCreateImage( cvGetSize(image), IPL_DEPTH_32F, 1 ); 
	IplImage* mapy = cvCreateImage( cvGetSize(image), IPL_DEPTH_32F, 1 ); 
	cvInitUndistortMap(intrinsic, distortion, mapx, mapy); 

	// ī޶ Է  ְ   ÿ ȭ鿡 Ÿ.
	// 
	cvNamedWindow( "Undistort" ); 
	while(image) 
	{
		IplImage *t = cvCloneImage(image); 
		cvShowImage( "Calibration", image ); 	//   ȭ 
		cvRemap( t, image, mapx, mapy ); 		// ְ 
		cvReleaseImage(&t); 
		cvShowImage("Undistort", image);		// ְ ŵ  ȭ 

		// Ͻ/  ESC Ű Է 
		int c = cvWaitKey(15); 
		if(c == 'p') 
		{ 
			c = 0; 
			while( c != 'p' && c != 27 )
				c = cvWaitKey(250); 
		} 
		if(c == 27) 
			break; 
		image = cvQueryFrame( capture ); 
	} 

	return 0; 
}
