// : ex2-3.exe <avifile>
//

#include "cv.h"
#include "highgui.h"

int        g_slider_position = 400;
CvCapture* g_capture         = NULL;

void onTrackbarSlide(int pos) 
{
	cvSetCaptureProperty(g_capture, CV_CAP_PROP_POS_FRAMES, pos);
}

int main(int argc, char** argv) 
{
	cvNamedWindow( "Example3", CV_WINDOW_AUTOSIZE );
	g_capture = cvCreateFileCapture( argv[1] );

	int frames = (int) cvGetCaptureProperty(g_capture, CV_CAP_PROP_FRAME_COUNT);

	if( frames != 0 )
	{
		cvCreateTrackbar("Position", "Example3", &g_slider_position,
			frames, onTrackbarSlide);
	}
	
	IplImage* frame;
	int pos;
	char c;
	
	while(1) 
	{
		frame = cvQueryFrame( g_capture );
		if( !frame ) break;
		pos = (int)cvGetCaptureProperty(g_capture, CV_CAP_PROP_POS_FRAMES);
		cvSetTrackbarPos("Position", "Example3", pos);
		cvShowImage( "Example3", frame );
		c = cvWaitKey(33);
		if( c == 27 ) break;
	}

	cvReleaseCapture( &g_capture );
	cvDestroyWindow( "Example3" );
	
	return 0;
}
