// DFT ̿Ͽ  A Ŀ B   ϱ. 
//   C ȴ.
// 
// A: M1xN1, B: M2xN2, C: (A->rows+B->rows-1)x(A->cols+B->cols-1)

#include <cv.h>
#include <highgui.h>

void speedy_convolution(const CvMat* A, const CvMat* B, CvMat* C) 
{
	int dft_M = cvGetOptimalDFTSize( A->rows + B->rows - 1 );
	int dft_N = cvGetOptimalDFTSize( A->cols + B->cols - 1 );

	CvMat* dft_A = cvCreateMat( dft_M, dft_N, A->type );
	CvMat* dft_B = cvCreateMat( dft_M, dft_N, B->type );
	CvMat tmp;

	// A  dft_A ϰ, 2  · Ű. 
	//   ȼ 0 ä. 
	// 
	cvGetSubRect( dft_A, &tmp, cvRect(0, 0, A->cols, A->rows) ); 
	cvCopy( A, &tmp ); 
	cvGetSubRect( dft_A, &tmp, cvRect(A->cols, 0, dft_A->cols - A->cols, A->rows) ); 
	cvZero( &tmp );

	// cvDFT() Լ ȣϸ鼭 nonzero_rows  Ͽ  
	// dft_A  Ʒ 0 ä ʾƵ ϴ.
	// 
	cvDFT( dft_A, dft_A, CV_DXT_FORWARD, A->rows );

	//  ° (B) ؼ  ۾ ݺѴ. 
	// 
	cvGetSubRect( dft_B, &tmp, cvRect(0, 0, B->cols, B->rows) ); 
	cvCopy( B, &tmp ); 
	cvGetSubRect( dft_B, &tmp, cvRect(B->cols, 0, dft_B->cols - B->cols, B->rows) ); 
	cvZero( &tmp );

	cvDFT( dft_B, dft_B, CV_DXT_FORWARD, B->rows );

	// (convolution)   (correlation) Ϸ 
	// flags CV_DXT_MUL_CONJ ϶.
	// 
	cvMulSpectrums( dft_A, dft_B, dft_A, 0 );

	//    κи Ѵ.
	// 
	cvDFT( dft_A, dft_A, CV_DXT_INV_SCALE, C->rows ); 
	cvGetSubRect( dft_A, &tmp, cvRect(0, 0, C->cols, C->rows) );

	cvCopy( &tmp, C );

	cvReleaseMat( &dft_A ); 
	cvReleaseMat( &dft_B ); 
} 

int main(int argc, char** argv)
{
	int M1 = 2;
	int M2 = 2;
	int N1 = 2;
	int N2 = 2;

	CvMat* A = cvCreateMat( M1, N1, CV_32F );
	CvMat* B = cvCreateMat( M2, N2, A->type );
	CvMat* C = cvCreateMat( A->rows + B->rows - 1, A->cols + B->cols - 1, A->type );

	speedy_convolution(A, B, C);

	cvReleaseMat( &A );
	cvReleaseMat( &B );
	cvReleaseMat( &C );

	return 0;
}
