// : ex9_avgback.exe <avi_file>
//

#include "cxcore.h"
#include "cv.h"
#include "highgui.h"
#include "conncomp.h"
#include <stdio.h>

#define CHANNELS 3 

typedef struct _CodeElement {
	uchar 	max[CHANNELS]; 			//   Ӱ谪
	uchar 	min[CHANNELS]; 			//   Ӱ谪
	uchar 	learnHigh[CHANNELS]; 	//  н Ӱ谪
	uchar 	learnLow[CHANNELS]; 	//  н Ӱ谪
	int 	t_last_update;			//  ŵ ð
	int 	stale;					//    ִ  
} CodeElement; 

typedef struct _CodeBook {
	CodeElement**	cb;
	int 			numEntries;
	int 			t; 			//  Ƚ 
} CodeBook; 

///////////////////////////////////////////////////////////////// 
// int update_codebook(uchar* p, CodeBook& c, unsigned* cbBounds, int numChannels)
//
// ο ͸ ̿Ͽ ڵ ׸ Ѵ.
//
// p 			YUV ȼ 
// c 			ش ȼ ڵ 
// cbBounds 	н  (뷫 10̸ ϴ.) 
// numChannels	 ä  
// 
// :	cvBounds 迭 ũ numChannels ƾ Ѵ. 
// ȯ:	ڵ ε
// 
int update_codebook(uchar* p, CodeBook& c, unsigned* cbBounds, int numChannels)
{ 
	int i, n;
	unsigned int high[3], low[3]; 

	for( n = 0 ; n < numChannels ; n++ ) 
	{
		high[n] = *(p+n) + *(cbBounds+n); 
		if( high[n] > 255 ) high[n] = 255; 
		low[n] = *(p+n) - *(cbBounds+n); 
		if( low[n] < 0 ) low[n] = 0;
	} 
	int matchChannel;

	// ̹ ϴ ڵ(codeword) ϴ ˻Ѵ. 
	// 
	for( i = 0 ; i < c.numEntries ; i++ )
	{
		matchChannel = 0;

		for( n = 0 ; n < numChannels ; n++ )
		{ 
			//  äο  ׸ ã´
			if( (c.cb[i]->learnLow[n] <= *(p+n)) && 
				(*(p+n) <= c.cb[i]->learnHigh[n]) )
			{ 
				matchChannel++;
			} 
		} 

		if( matchChannel == numChannels ) // ׸ ߰ߵǾ  
		{
			c.cb[i]->t_last_update = c.t; 

			// ù ° äο ؼ ڵ带 Ѵ. 
			for( n = 0 ; n < numChannels ; n++ )
			{
				if( c.cb[i]->max[n] < *(p+n) ) 
				{
					c.cb[i]->max[n] = *(p+n); 
				} 
				else if( c.cb[i]->min[n] > *(p+n) ) 
				{
					c.cb[i]->min[n] = *(p+n);
				} 
			} 
			break;
		} 
	} 

	// OVERHEAD TO TRACK POTENTIAL STALE ENTRIES
	// 
	for( int s = 0 ; s < c.numEntries ; s++ )
	{
		//  ڵ ׸ stale Ǿ ˻Ѵ. 
		// 
		int negRun = c.t - c.cb[s]->t_last_update; 
		if( c.cb[s]->stale < negRun ) c.cb[s]->stale = negRun;
	} 

	//  ʿϴٸ ο ڵ带  
	// 
	if( i == c.numEntries ) //  ϴ ڵ尡 ٸ,  ϳ Ѵ 
	{
		CodeElement **foo = new CodeElement* [c.numEntries+1]; 

		for( int ii = 0 ; ii < c.numEntries ; ii++ ) {
			foo[ii] = c.cb[ii]; 
		} 
		foo[c.numEntries] = new CodeElement; 
		if(c.numEntries) delete [] c.cb; 
		c.cb = foo; 
		for( n = 0 ; n < numChannels ; n++ ) 
		{
			c.cb[c.numEntries]->learnHigh[n] = high[n]; 
			c.cb[c.numEntries]->learnLow[n] = low[n]; 
			c.cb[c.numEntries]->max[n] = *(p+n); 
			c.cb[c.numEntries]->min[n] = *(p+n);
		}
		c.cb[c.numEntries]->t_last_update = c.t;
		c.cb[c.numEntries]->stale = 0;
		c.numEntries += 1;
	} 

	// н 踦 ݾ Ѵ. 
	//
	for( n = 0 ; n < numChannels ; n++ )
	{
		if(c.cb[i]->learnHigh[n] < high[n]) c.cb[i]->learnHigh[n] += 1;
		if(c.cb[i]->learnLow[n] > low[n]) c.cb[i]->learnLow[n] -= 1;
	}
	return (i); 
} 

///////////////////////////////////////////////////////////////////
//int clear_stale_entries(CodeBook &c)
// 
// 
// н ϴ   ð  ֱ  Լ
// ȣϿ  ڵ ׸ ϶.
//
// c			 ڵ
//
// ȯ: 	 ׸ 
//
int clear_stale_entries(CodeBook &c)
{
	int staleThresh = c.t >> 1;
	int* keep = new int [c.numEntries];
	int keepCnt = 0;

	// SEE WHICH CODEBOOK ENTRIES ARE TOO STALE
	//
	for( int i = 0 ; i < c.numEntries ; i++ )
	{
		if( c.cb[i]->stale > staleThresh )
			keep[i] = 0; //Mark for destruction
		else
		{
			keep[i] = 1; //Mark to keep
			keepCnt += 1;
		}
	}

	//  ͸ 
	//
	c.t = 0; // Full reset on stale tracking
	CodeElement** foo = new CodeElement*[keepCnt];
	int k = 0;
	for( int ii = 0 ; ii < c.numEntries ; ii++ )
	{
		if(keep[ii])
		{
			foo[k] = c.cb[ii];

			// We have to refresh these entries for next clearStale
			foo[k]->t_last_update = 0;
			k++;
		}
	}

	// ϱ
	//
	delete [] keep;
	delete [] c.cb;
	c.cb = foo;
	int numCleared = c.numEntries - keepCnt;
	c.numEntries = keepCnt;
	return(numCleared);
}

//////////////////////////////////////////////////////////// 
// uchar background_diff(uchar* p, CodeBook& c, int numChannels, int* minMod, int* maxMod)
// 
// ־ ȼ ڵϿ ؼ, ش ȼ ڵϿ ԵǴ ǴѴ. 
// 
// p 				ȼ  (YUV) 
// c 				ڵ 
// numChannels 	ä  
// maxMod 		ο ȼ ̶ Ǹ 
// 				 (   ִ)  max level Ѵ.
// minMod 		ο ȼ ̶ Ǹ
// 				 (   ִ)  min level . 
// 
// : 		minMod maxMod numChannelsŭ ũ⸦ ´ 
// 			, 3 ä̸ minMod[3], maxMod[3] Ѵ.
// 			 äθ max min   ִ. 
// ȯ:	0 => , 255 =>  
// 
uchar background_diff(uchar* p, CodeBook& c, int numChannels, int* minMod, int* maxMod)
{
	int i, matchChannel;

	// ̹ ϴ ڵ忡 ԵǴ ˻
	// 
	for( i = 0 ; i < c.numEntries ; i++ ) 
	{
		matchChannel = 0; 
		for( int n = 0 ; n < numChannels ; n++ ) 
		{
			if( (c.cb[i]->min[n] - minMod[n] <= *(p+n)) && 
				(*(p+n) <= c.cb[i]->max[n] + maxMod[n]) ) {
					matchChannel++; 	// äο ´ ׸ ã´. 
			} else {
				break;
			}
		} 

		if( matchChannel == numChannels ) {
			break; 	// äο ϴ ׸ ã´. 
		} 
	} 
	if( i >= c.numEntries ) return(255); 
	return(0); 
} 

int main(int argc, char** argv)
{
	int i;
	int count = 0;
	int trainig_frames = 100;
	int imageLen;

	IplImage* frame = NULL;
	CvCapture* capture = cvCreateFileCapture( argv[1] );

	CodeBook*	codebook = NULL;
	IplImage*	yuvImage = NULL;
	IplImage*   mask     = NULL;
	IplImage*   maskCC   = NULL;
	uchar*		pColor;			// YUV pointer

	unsigned cbBounds[CHANNELS]; //Code Book bounds for learning
	int nChannels = CHANNELS;

	int maxMod[CHANNELS];
	int minMod[CHANNELS];

	maxMod[0] = 10;  //Set color thresholds to default values
	minMod[0] = 10;
	maxMod[1] = 5;
	minMod[1] = 5;
	maxMod[2] = 5;
	minMod[2] = 5;
	cbBounds[0] = 10;
	cbBounds[0] = 5;
	cbBounds[0] = 5;

	cvNamedWindow( "Codebook", CV_WINDOW_AUTOSIZE );
	cvNamedWindow( "Mask", CV_WINDOW_AUTOSIZE );

	while(1) 
	{
		frame = cvQueryFrame( capture );
		if( !frame ) break;

		// ȼ ŭ ڵ ϰ ʱȭѴ. (ó  )
		if( 0 == count ) 
		{
			mask = cvCreateImage( cvGetSize(frame), IPL_DEPTH_8U, 1 );
			maskCC = cvCreateImage( cvGetSize(frame), IPL_DEPTH_8U, 1 );
			cvSet(mask, cvScalar(255));
			cvSet(maskCC, cvScalar(255));

			yuvImage = cvCloneImage(frame);

			imageLen = frame->width * frame->height;
			codebook = new CodeBook[imageLen];

			for( i = 0 ; i < imageLen ; i++ )
			{
				codebook[i].numEntries = 0;
			}

			for( i = 0 ; i < nChannels ; i++ )
			{
				cbBounds[i] = 10;	// Learning bounds factor
			}
		}

		cvCvtColor( frame, yuvImage, CV_BGR2YCrCb );

		//    ̿Ͽ   
		if( count < trainig_frames ) 
		{
			pColor = (uchar *)((yuvImage)->imageData);

			for( int c = 0 ; c < imageLen ; c++ )
			{
				update_codebook(pColor, codebook[c], cbBounds, nChannels);
				pColor += 3;
			}
		}
		else 
		{
			//  ü 
			uchar maskPixelCodeBook;
			pColor = (uchar *)((yuvImage)->imageData);   // 3 channel yuv image
			uchar *pMask = (uchar *)((mask)->imageData); // 1 channel image
			for( int c = 0 ; c < imageLen ; c++ )
			{
				maskPixelCodeBook = background_diff(pColor, codebook[c], nChannels, minMod, maxMod);
				*pMask++ = maskPixelCodeBook;
				pColor += 3;
			}

			cvCopy(mask, maskCC);
			find_connected_components(maskCC);
		}
		count++;

		if( count % 30 == 0 ) 
		{
			for( int c = 0 ; c < imageLen ; c++ )
			{
				clear_stale_entries(codebook[c]);
			}
		}

		cvFlip(maskCC, maskCC, 0);
		cvShowImage( "Codebook", frame );
		cvShowImage( "Mask", maskCC );

		char c = cvWaitKey(33);
		if( c == 27 ) break;
	}

	if( codebook ) 
	{
		delete [] codebook;

		cvReleaseImage( &mask );
		cvReleaseImage( &yuvImage );
		cvReleaseCapture( &capture );
	}

	cvDestroyWindow( "Codebook" );
	cvDestroyWindow( "Mask" );

	return 0;
}
